<?php

$loader = new admin_logs();

class admin_logs
{
	var $output = "";
	
	function admin_logs()
	{
		global $IN, $OUTPUT;

		switch($IN["act"])
		{
            case 'leech':
				$this->logs_leech();
				break;
            case 'downloads':
                $this->logs_downloads();
                break;
            case 'empty':
                $this->emptyLogFile();
                break;
		}
		$OUTPUT->add_output($this->output);
	}
	
	function logs_leech()
	{
		global $DB, $IN, $CONFIG, $guser, $sid, $std;

		$this->output .= admin_head(GETLANG("nav_logs"), GETLANG("nav_leechlogs"));

		if (!$IN["limit"])
		    $limit = 0;
	    else
		    $limit = intval($IN["limit"]);

        $this->output .= "[ <a href='admin.php?sid=$sid&area=logs&act=empty&id=1'>Empty this log file</a> ]<br>";

		// Type 1 is leech logs
		$DB->query("SELECT * FROM `dl_logs` WHERE `type`='1'");
		$rows = $DB->num_rows();
        $users = $guser->getAllUsers();
		$DB->query("SELECT * FROM `dl_logs` WHERE `type`='1' ORDER BY `time` DESC LIMIT $limit , {$CONFIG[links_per_page]}");

		$this->output .= $std->pages($rows, $CONFIG["links_per_page"], "admin.php?sid=$sid&area=logs&act=leech");
		$this->output .= new_table();
		$this->output .= new_row(-1, "acptablesubhead");
			$this->output .= GETLANG("log_file");
			$this->output .= new_col();
			$this->output .= GETLANG("log_refer");
			$this->output .= new_col();
			$this->output .= GETLANG("log_time");
			$this->output .= new_col();
			$this->output .= GETLANG("log_ip");
            $this->output .= new_col();
			$this->output .= GETLANG("user");
		if ( $myrow = $DB->fetch_row() )
		{
			do
			{
				$this->output .= new_row();
					$this->output .= "<a href='index.php?dlid={$myrow['file']}'>{$myrow['filename']}</a>";
					$this->output .= new_col();
					$this->output .= $this->logs_formaturl($myrow['referer']);
					$this->output .= new_col();
					$this->output .= date("d/M/y G:i:s", $myrow['time']);
					$this->output .= new_col();
					$this->output .= "<a href='http://whois.sc/{$myrow['IP']}'>{$myrow['IP']}</a>";
                    $this->output .= new_col();
					$this->output .= $users[$myrow['userid']]['username'];
			} while ( $myrow = $DB->fetch_row() );
		}
		$this->output .= end_table();
			
		$this->output .= admin_foot();
	}

    function logs_downloads()
    {
        global $DB, $IN, $CONFIG, $guser, $sid, $std;

        $this->output .= admin_head(GETLANG("nav_logs"), GETLANG("nav_downloadlogs"));

        if (!$IN["limit"])
            $limit = 0;
        else
            $limit = intval($IN["limit"]);

        $this->output .= "[ <a href='admin.php?sid=$sid&area=logs&act=empty&id=2'>Empty this log file</a> ]<br>";

        // Type 1 is leech logs
        $DB->query("SELECT * FROM `dl_logs` WHERE `type`='2'");
        $rows = $DB->num_rows();
        $users = $guser->getAllUsers();
        $DB->query("SELECT * FROM `dl_logs` WHERE `type`='2' ORDER BY `time` DESC LIMIT $limit , {$CONFIG[links_per_page]}");

        $this->output .= $std->pages($rows, $CONFIG["links_per_page"], "admin.php?sid=$sid&area=logs&act=downloads");
        $this->output .= new_table();
        $this->output .= new_row(-1, "acptablesubhead");
            $this->output .= GETLANG("log_file");
            $this->output .= new_col();
            $this->output .= GETLANG("log_refer");
            $this->output .= new_col();
            $this->output .= GETLANG("log_time");
            $this->output .= new_col();
            $this->output .= GETLANG("log_ip");
            $this->output .= new_col();
			$this->output .= GETLANG("user");
        if ( $myrow = $DB->fetch_row() )
        {
            do
            {
                $this->output .= new_row();
                    $this->output .= "<a href='index.php?dlid={$myrow['file']}'>{$myrow['filename']}</a>";
                    $this->output .= new_col();
                    $this->output .= $this->logs_formaturl($myrow['referer']);
                    $this->output .= new_col();
                    $this->output .= date("d/M/y G:i:s", $myrow['time']);
                    $this->output .= new_col();
                    $this->output .= "<a href='http://whois.sc/{$myrow['IP']}'>{$myrow['IP']}</a>";;
                    $this->output .= new_col();
					$this->output .= $users[$myrow['userid']]['username'];
            } while ( $myrow = $DB->fetch_row() );
        }
        $this->output .= end_table();

        $this->output .= admin_foot();
    }

    function emptyLogFile()
    {
        global $IN, $std, $DB, $sid, $OUTPUT;

        if ($IN["confirm"])
        {
            $OUTPUT->add_output(admin_head(GETLANG("nav_logs"), GETLANG("nav_downloadlogs")));
            $DB->query("DELETE FROM `dl_logs` WHERE type={$IN['id']}");
            $OUTPUT->add_output(GETLANG("logsemptied")."<br><br>");
            $OUTPUT->add_output("+ <a href='admin.php?sid=$sid&area=logs&act=leech'>".GETLANG("backto")." ".GETLANG("nav_leechlogs")."</a><br>");
            $OUTPUT->add_output(admin_foot());
            return;

        }
        else if ($IN["cancel"])
        {
            $OUTPUT->add_output(GETLANG("emptylogcancel")."<br><br>");

            $OUTPUT->add_output("+ <a href='admin.php?sid=$sid&area=logs&act=leech'>".GETLANG("backto")." ".GETLANG("nav_leechlogs")."</a><br>");
            return;
        }
        else
        {
            $std->warning (GETLANG("warn_emptylogs")."<p>"
                    ."<form method='post' action='admin.php?sid=$sid&area=logs&act=empty&id={$IN['id']}'>"
                    ."<input type='Submit' name='confirm' value='".GETLANG("yes")."'> <input type='Submit' name='cancel' value='".GETLANG("no")."'> </form>");

        }
    }

	function logs_formaturl($url)
	{
		$parseurl = parse_url($url);
		$shorturl = $parseurl['host'];
		return "<a href='$url'>$shorturl</a>";
	}
}

?>