<?php

/*********************************************************
 * Name: gallery.php
 * Author: Dave Conley
 * Contact: realworld@blazefans.com
 * Description: Functions for thumbnail gallery management
 * Version: 4.00
 * Last edited: 16th March, 2004
 *********************************************************/

class gallery
{
	var $html;
	
	function gallery()
	{
		global $rwdInfo, $OUTPUT, $DB;
		$this->html = $OUTPUT->load_template("skin_gallery");
		if ( !$rwdInfo->imgs_saved )
		{
			$DB->query("SELECT * FROM dl_images");
			if ($myrow = $DB->fetch_row())
			{
				do
				{
					// Add image to cache
					$rwdInfo->image_cache[$myrow["dlid"]][$myrow["id"]] = $myrow;
				} while ($myrow = $DB->fetch_row());
			}
			$rwdInfo->imgs_saved = 1;
		}
	}

	// Removes all thumbnails from download
	function remove_thumbs($id = 0)
	{
		global $DB, $CONFIG, $rwdInfo;
		if ( $id == 0 )
			return;
		$result = $DB->query("SELECT * FROM dl_images WHERE dlid=$id");
		if ($rows = $DB->fetch_row($result))
		{
			do
			{
				$file = $CONFIG['imagesfolder']."/".$rows["realName"];
				if(is_file($file))
					unlink($file);
				$file = $CONFIG['imagesfolder']."/t_".$rows["realName"];
				if(is_file($file))
					unlink($file);
			} while ($rows = $DB->fetch_row($result));
		}
	}

	function removeThumb($thispage, $return)
	{
		global $DB, $IN, $CONFIG, $rwdInfo, $sid, $std, $act;
		if ($IN["confirm"])
		{
			$result = $DB->query("SELECT * FROM dl_images WHERE id=$IN[imgid]");
			$rows = $DB->fetch_row($result);
			if ( is_file( $CONFIG['imagesfolder']."/".$rows["realName"] ) )
				unlink( $CONFIG['imagesfolder']."/".$rows["realName"] );
			if ( is_file( $CONFIG['imagesfolder']."/t_".$rows["realName"] ) )
				unlink( $CONFIG['imagesfolder']."/t_".$rows["realName"] );
			$result = $DB->query("DELETE FROM dl_images WHERE id=$IN[imgid]");
			$std->info (GETLANG("deldl")."<p>"."<a href='$return'>".GETLANG("continue")."</a>");
		}
		else if ($IN["cancel"])
		{
			$std->info (GETLANG("delcancel")."<p>"."<a href='$return'>".GETLANG("continue")."</a>");
		}
		else
		{
			$std->warning (GETLANG("warn_imgdel")."<p>"
							."<form method='post' action='".$thispage."'>"
							."<input type='hidden' name='imgid' value='".$_GET["imgid"]."'>"
							."<input type='Submit' name='confirm' value='".GETLANG("yes")."'>"
							."<input type='Submit' name='cancel' value='".GETLANG("no")."'> </form>");

		}
	}

	function thumbTable($dlid, $symid, $owner, $admin=0)
	{
		global $DB, $IN, $CONFIG, $rwdInfo, $guser, $sid;
		
		if ( !$CONFIG["display_thumbs"] )
		    return "";
		
		$firsttime = true;
		$imageArray = $rwdInfo->image_cache[$dlid];
		if ( !$imageArray )
			return "";

		$data = $this->html->thumb_table_head();

		$count = 0;
		$rows = 0;
		foreach($imageArray as $imgVal )
		{

			// Roughly Calculate thumbnail dimensions in case a thumbnail doesnt exist
			$size = explode( "x", $imgVal["size"] );
			$width = $size[0];
			$height = $size[1];
			if ( $width > $height )
			{
			    if ( $width > $CONFIG["thumbWidth"] )
				$dims = "width=$CONFIG[thumbWidth]";
			    else
				$dims = "width=$width";
			}
			else
			{
			    if ( $height > $CONFIG["thumbHeight"] )
				$dims = "height=$CONFIG[thumbHeight]";
			    else
				$dims = "height=$height";
			}
			
			// If we have done all the thumbs allowed for this row then start a new one
			if ( $count >= $CONFIG["num_gall_cols"] )
			{
				$count = 0;
				$data .= $this->html->thumb_end_row();
				$rows++;
			}

			$imgid = $imgVal["id"];
			
			$thisthumb = array();
			// Add the delete image link if required
			$values = array();
			if ( $admin )
			{
				if ( $guser->isAdmin )
					$values['editlink'] = "?sid=$sid&area=files&act=deleteimg&imgid=$imgid&id=$symid";
			}
			else if ( $owner == $guser->userid || $guser->isAdmin )
				$values['editlink'] = "?ACT=deleteimg&imgid=$imgid&did=$dlid&symid=$symid";
			if ( $values['editlink'] )
				$editrow = $this->html->thumb_editrow($values);
			
			$thisthumb['editrow'] = $editrow;
			
			// Main thumb data
			$thisthumb['imageurl'] = $CONFIG['imagesurl']."/{$imgVal['realName']}";			
			// If thumbnail exists then use that otherwise show a resized version of the full image
			if (is_file($CONFIG['imagesfolder']."/t_".$imgVal["realName"]))
				$thisthumb['thumburl'] = $CONFIG['imagesurl']."/t_{$imgVal['realName']}";
			else
			{
				$thisthumb['thumburl'] = $CONFIG['imagesurl']."/{$imgVal['realName']}";
				$thisthumb['dims'] = $dims;
			}
			$thisthumb['cellwidth'] = "##WIDTH##";
			$data .= $this->html->thumb_cell($thisthumb);
			$count++;
		}
		$width == 0;
		if ( $rows == 0 )
		{
			$width = intval(100/$count);
			$width .= "%";
		}
		else
		{	
			$width = intval(100/$CONFIG["num_gall_cols"]);
			$width .= "%";
			while ( $count++ < $CONFIG["num_gall_cols"] )
			{
				$thisthumb = array();
				$thisthumb['cellwidth'] = "##WIDTH##";
				$data .= $this->html->thumb_empty($thisthumb);
			}
		}
		$data = str_replace( "##WIDTH##", $width, $data );
		$data .= $this->html->thumb_table_foot();
		
		return $data;
	}
	
	function getFirstThumb($id, $owner)
	{
		global $DB, $IN, $CONFIG, $rwdInfo, $guser, $sid;
		if ( !$CONFIG["display_thumbs"] )
		    return "";
		
		$firsttime = true;
		$imageArray = $rwdInfo->image_cache[$id];
		if ( !$imageArray )
			return "";
		
		foreach($imageArray as $imgVal )
		{
			// Roughly Calculate thumbnail dimensions in case a thumbnail doesnt exist
			$size = explode( "x", $imgVal["size"] );
			$width = $size[0];
			$height = $size[1];
			if ( $width > $height )
			{
			    if ( $width > $CONFIG["thumbWidth"] )
				$dims = "width=$CONFIG[thumbWidth]";
			    else
				$dims = "width=$width";
			}
			else
			{
			    if ( $height > $CONFIG["thumbHeight"] )
				$dims = "height=$CONFIG[thumbHeight]";
			    else
				$dims = "height=$height";
			}
			
			$imgid = $imgVal["id"];
			
			$thisthumb = array();
					
			// Main thumb data
			$thisthumb['imageurl'] = $CONFIG['imagesurl']."/{$imgVal['realName']}";			
			// If thumbnail exists then use that otherwise show a resized version of the full image
			if (is_file($CONFIG['filesfolder']."/t_".$imgVal["realName"]))
				$thisthumb['thumburl'] = $CONFIG['imagesurl']."/t_{$imgVal['realName']}";
			else
			{
				$thisthumb['thumburl'] = $CONFIG['imagesurl']."/{$imgVal['realName']}";
				$thisthumb['dims'] = $dims;
			}
			$thisthumb['cellwidth'] = "##WIDTH##";
			$data = $this->html->thumb_plain($thisthumb);
			break; // cos we only want one!
		}
		return $data;
	}
}

?>