<?php
/*********************************************************
 * Name: stats.php
 * Author: Dave Conley
 * Contact: realworld@blazefans.com
 * Description: Allows you to display a number of stats on your website
 * Version: 4.0
 * Last edited: 18th August, 2004
 *********************************************************/

class stats
{
	var $html;
	function stats()
	{
		global $OUTPUT;
		
		$this->html = $OUTPUT->load_template("skin_stats");
	}
	
	function topDownloads($limit = "0,5")
	{
		global $DB, $std, $guser;
		$DB->query("SELECT l.*, sym.*
                    FROM dl_symlinks sym
                    LEFT JOIN dl_links l ON (l.did=sym.sym_did)
                    WHERE l.approved=1
                    ORDER BY `downloads` DESC LIMIT $limit");
		$output = "";
		if ($myrow = $DB->fetch_row())
		{
			do
			{
                if ( !$std->canAccess($myrow["sym_catid"], "canBrowse" ) )
                    continue;
				$output .= $this->html->topdownloads($myrow);
			} while ($myrow = $DB->fetch_row());
		}
		return $output;
	}
	
	function topRatedDownloads($limit="0,5")
	{
		global $DB, $std, $guser;
		$DB->query("SELECT l.*, sym.*
                    FROM dl_symlinks sym
                    LEFT JOIN dl_links l ON (l.did=sym.sym_did)
                    WHERE l.approved=1 and l.votes > 5
                    ORDER BY `userrating` DESC LIMIT $limit");
		$output = "";
		if ($myrow = $DB->fetch_row())
		{
			do
			{
                if ( !$std->canAccess($myrow["sym_catid"], "canBrowse" ) )
                    continue;
				$output .= $this->html->topRatedDownloads($myrow);
			} while ($myrow = $DB->fetch_row());
		}
		return $output;
	}
	
	function latestDownloads($limit="0,5")
	{
		global $DB, $std, $guser;
		$DB->query("SELECT l.*, sym.*
                    FROM dl_symlinks sym
                    LEFT JOIN dl_links l ON (l.did=sym.sym_did)
                    WHERE l.approved=1
                    ORDER BY `date` DESC LIMIT $limit");
		
		$output = "";
		if ($myrow = $DB->fetch_row())
		{
			do
			{
                if ( !$std->canAccess($myrow["sym_catid"], "canBrowse" ) )
                    continue;
				$output .= $this->html->latestDownloads($myrow);
			} while ($myrow = $DB->fetch_row());
		}
		
		return $output;
	}
}

?>