<?php

/*********************************************************
 * Name: usercp.php
 * Author: Dave Conley
 * Contact: realworld@blazefans.com
 * Description: Functions for managing user control panel
 * Version: 4.00
 * Last edited: 9th March, 2004
 *********************************************************/

require_once ROOT_PATH."/functions/files.php";

class usercp extends files
{
	var $ucphtml;
	var $files;
	var $output;
	
	function usercp()
	{
	    global $IN, $OUTPUT, $guser, $std;
		$this->ucphtml = $OUTPUT->load_template("skin_usercp");
		$this->html = $OUTPUT->load_template("skin_files");
		$this->files = new files();

        if ( $guser->isGuest )
        {
            $std->error(GETLANG("er_noperms"));
            return;
        }
		$std->updateNav(" > ".GETLANG("nav_usercp"), 0);
		switch($IN["area"])
		{
			case 'files':
				$main = $this->showfiles(1);
				break;

			case 'pending':
				$main = $this->showfiles(0);
				break;

			case 'profile':
				$main = $this->editPrefs();
				break;

			case 'editdl':
				$main = $this->ucpeditdl();
				break;
				
			case 'handleInput':
				$main = $this->ucpHandleInput();
				break;
				
			case 'home':
			default:
				$main = $this->showhome();
				break;
		}
		
		$this->ucp_wrapper($main, $IN["area"]);
		
		$OUTPUT->add_output($this->output);
	}
	
	function ucp_wrapper($main, $section)
	{
		global $std, $guser;
		$data = array(  "ucp_main" => $main,
                        "homeclass" => "ucpoff",
                        "profileclass" => "ucpoff",
                        "appclass" => "ucpoff",
                        "unappclass" => "ucpoff" );

		switch($section)
		{
			case 'files':
				$data['appclass'] = "ucpon";
				break;

			case 'pending':
				$data['unappclass'] = "ucpon";
				break;

			case 'profile':
				$data['profileclass'] = "ucpon";
				break;

			case 'editdl':
				$data['homeclass'] = "ucpon";
				break;
				
			case 'home':
			default:
				$data['homeclass'] = "ucpon";
				break;
		}
		if ( $guser->userid == 0 )
		{
			$std->warning(GETLANG("warn_notloggedin"));
			return;
		}
		$this->output .= $this->ucphtml->ucp_main($data);
	
	}

	function showhome()
	{
		global $DB, $OUTPUT, $guser, $std;

		$id = $guser->userid;
		
		$guser->updateMemberExtra("`{$guser->db_id}`='$id'", "`mid`='$id'");
		$userdata = $std->updateLimits($guser->userdetails);
	
		$bandwidth = $std->my_filesize($userdata["bandwidth"])." remaining";
		if ( $userdata["bandwidth"] <= 0 )
			$bandwidth = "<font color='red'><b>".$bandwidth."</b></font>";
		$time = $userdata["bandwidth_time"] - time();
		if ($time<0)
			$time = 0;
		$timeArray = $std->calc_time($time);
		$timeStr = "$timeArray[days] Days, $timeArray[hours] Hours, $timeArray[minutes] Minutes";

		$files = $userdata["files"]." files remaining";
		if ( $userdata["files"] == 0 )
			$files = "<font color='red'><b>".$files."</b></font>";
		$time = $userdata["files_time"] - time();
		if ( $time < 0 )
			$time = 0;
		$timeArray = $std->calc_time($time);
		$timeStr2 = "$timeArray[days] Days, $timeArray[hours] Hours, $timeArray[minutes] Minutes";

		$downloaded = $guser->userdetails['downloaded']." Downloaded";
		$uploaded = $guser->userdetails['uploaded']." Uploaded";

		//$data = array(   );

		//$limit_table .= $this->ucphtml->ucp_limits($data);

		$limits_info = GETLANG("limits_desc");
		if ( $guser->userdetails['no_restrict'] )
			$limits_info .= ".<br>".GETLANG("limits_off");
		else if ( $guser->userdetails['resetOnExpire'] )
			$limits_info .= ".<br>".GETLANG("limit_reset_on");
		else
			$limits_info .= ".<br>".GETLANG("limit_reset_off");
		
		$data = array(  "limits_info" => $limits_info,
						"bandwidth" => $bandwidth,
						"bandwidth_time" => $timeStr,
						"files" => $files,
						"files_time" => $timeStr2,

						"filesup" => $uploaded,
						"filesdown" => $downloaded,
						
						"username" => $guser->username,
						"email" => $guser->userdetails["email"],
						"registered" => ($guser->userdetails["regDate"]>0)?$std->formatDate($guser->userdetails["regDate"]):"Unknown",
						"group" => $guser->userdetails[$guser->db_g_title] );

		return $this->ucphtml->ucp_home($data);

	}

	function showfiles($approved=1)
	{
		global $CONFIG, $IN, $DB, $std, $guser;

		$owner = $guser->userid;

        if (!$IN["limit"])
            $limit = 0;
        else
            $limit = intval($IN["limit"]);

        $main_content = "";
        // Attempt to get custom download field data
        $customFields = array();
        if ( $CONFIG['doCustomFields'] )
        {
            $DB->query("SELECT * FROM dl_custom");

            while ( $cfrow = $DB->fetch_row() )
            {
                $index = "custom_".$cfrow['cid'];
                $customFields[$index] = $cfrow;
            }

        }

        if ($guser->userdetails['canApproveUploads'] && $approved == 0)
        {
            // This extra query is just to get the muber of files
            $result = $DB->query(  "SELECT l.*, sym.*
                        FROM dl_symlinks sym
                        LEFT JOIN dl_links l ON (l.did=sym.sym_did)
                        WHERE l.approved=$approved");

            $numfiles = $DB->num_rows($result);

            $result = $DB->query(  "SELECT l.*, cd.*, sym.*
                        FROM dl_symlinks sym
                        LEFT JOIN dl_links l ON (l.did=sym.sym_did)
                        LEFT JOIN dl_custom_data cd ON (cd.uid=l.did)
                        WHERE l.approved=$approved
                        LIMIT $limit , {$CONFIG[links_per_page]}");
        }
        else
        {
            // This extra query is just to get the muber of files
            $result = $DB->query(  "SELECT l.*, sym.*
                        FROM dl_symlinks sym
                        LEFT JOIN dl_links l ON (l.did=sym.sym_did)
                        WHERE l.owner=$owner AND l.approved=$approved");

            $numfiles = $DB->num_rows($result);

            $result = $DB->query(  "SELECT l.*, cd.*, sym.*
                        FROM dl_symlinks sym
                        LEFT JOIN dl_links l ON (l.did=sym.sym_did)
                        LEFT JOIN dl_custom_data cd ON (cd.uid=l.did)
                        WHERE l.owner=$owner AND l.approved=$approved
                        LIMIT $limit , {$CONFIG['links_per_page']}");
        }

		if (!$myrow = $DB->fetch_row($result))
		{
			$main_content .= $std->info("No files to display");
			return $main_content;
		}

		if ( $approved )
			$area = "files";
		else
			$area = "pending";

		$pages = $std->pages($numfiles, $CONFIG["links_per_page"], "index.php?ACT=usercp&area=$area");
		$forminput = "index.php?ACT=usercp&area=handleInput";
		$data = array(  "pages" => "$pages",
						"approved" => $approved,
						"form_approve" => "$forminput",
                        "canModerate" => $std->canEdit($guser->userid));
		$main_content .= $this->ucphtml->ucp_listing_head($data);

		do
		{
			$id = $myrow["did"];
			$date = $std->convertDate($myrow["date"]);

			$name = $myrow["name"];
			if ( $std->isRecent($myrow["date"]) )
				$new = "NEW";
			else
				$new = "";
			if ( $std->isRecent($myrow["lastEdited"]) )
				$updated = "UPDATED";
			else
				$updated = "";
			if ($myrow["thumb"])
			{
				$thumb = "<img src='".$CONFIG['filesfolder']."/".$myrow["thumb"]."'>";
			}
			else
			{
				$thumb = GETLANG("nothumb");
			}

			$description = nl2br($myrow["description"]);
			$adminreview = nl2br($myrow["adminreview"]);

			if ($myrow["userrating"])
				$userrating = $myrow["userrating"];
			else
				$userrating = "n/a";
			if ($myrow["adminrating"] == 0)
				$adminrating = "n/a";
			else
				$adminrating = $myrow["adminrating"];

			$delete = "<a href='index.php?ACT=usercp&area=deletedl&id=$id'>".GETLANG("delete")."</a>";
			$edit = "<a href='index.php?ACT=usercp&area=editdl&did=$id'>".GETLANG("edit")."</a>";
			$download_link = "<a href='index.php?dl=".$myrow["did"]."'>".GETLANG("download_button")."</a>";

			$data = array(  "name" => $name,
							"new" => $new,
							"updated" => $updated,
							"date" => $date,
							"filesize" => $myrow["filesize"],
							"author" => $myrow["author"],
							"downloads" => $myrow["downloads"],
							"adminrating" => $adminrating,
							"userrating" => $userrating,
							"download_link" => "$download_link",
							"description" => "$description",
							"adminreview" => "$adminreview",
							"edit" => "$edit",
							"editvalue" => "$id",
                            "canModerate" => $std->canEdit($guser->userid));
			
			$main_content .= $this->ucphtml->ucp_listing_row($data);

		} while ( $myrow = $DB->fetch_row($result) );

		$data = array(  "order_boxes" => "",
						"displayApprove" => $this->showApprove($approved),
						"pages" => $pages,
                        "canModerate" => $std->canEdit($guser->userid) );
		$main_content .= $this->ucphtml->ucp_listing_foot($data);

		return $main_content;
	}

	function showApprove($test1)
	{
		global $guser;

		if ( $test1 )
			return false;
		
		if ($guser->userdetails['canApproveUploads'] )
			return true;
		return false;
	}
	
	function ucpHandleInput()
	{
		global $IN, $DB, $std, $rwdInfo;
		
		$ids = count($IN["dlid"]);
		
		if ( $ids == 0 )
		{
			$std->error(GETLANG("er_noselect"));
			return;
		}
		if ( $IN["deleteChecked"] )
		{
			if ($IN["confirm"])
			{
				for ( $i=0; $i<$ids; $i++ )
				{
					$id = $IN["dlid"]["$i"];
					if ( !$this->deleteLink($id) )
						$std->error(GETLANG("er_stderrprefix"));
				}
				$std->info (GETLANG("deldl")."<p>"."<a href='index.php?ACT=usercp&area=home'>".GETLANG("continue")."</a>");
			}
			else if ($IN["cancel"])
			{
				$std->info (GETLANG("delcancel")."<p>"."<a href='index.php?ACT=usercp&area=home'>".GETLANG("continue")."</a>");
			}
			else
			{
				$warntext = "<p><form method='post' action='index.php?ACT=usercp&area=handleInput'>";
				for ( $j=0; $j<$ids; $j++ )
					$warntext .= "<input type='hidden' name='dlid[]' value='".$IN["dlid"][$j]."'>";
				$warntext .= "<input type='hidden' name='deleteChecked' value='1'>";
				$warntext .= "<input type='Submit' name='confirm' value='".GETLANG("yes")."'> <input type='Submit' name='cancel' value='".GETLANG("no")."'> </form>";
				$std->warning (GETLANG("warn_dldel").$warntext);

			}
		}
		else if ( $IN['approveChecked'] )
		{
			for ( $i=0; $i<$ids; $i++ )
			{
				$id = $_POST["dlid"]["$i"];
				$DB->query("UPDATE dl_links SET approved='1' WHERE did=$id");

				$result = $DB->query("SELECT * FROM dl_links WHERE did=$id");
				$myrow = $DB->fetch_row($result);

				$this->incrementCounter($myrow["categoryid"], $id, $myrow['name'], $myrow['owner']);

			}
			$std->info(GETLANG("dlapproved").".<br>"."<a href='index.php?ACT=usercp&area=pending'>".GETLANG("continue")."</a>");
		}		
		
	}
	
	function ucpeditdl()
	{
		global $IN, $DB, $std, $rwdInfo;

		$dlid = $IN['did'];
		$result = $DB->query("SELECT l.*, sym.*
							  FROM dl_symlinks sym
							  LEFT JOIN dl_links l ON (l.did={$dlid})
							  WHERE sym.sym_did={$dlid}");
		$newdata = $myrow = $DB->fetch_row();
        $symid = $newdata['sym_id'];
		do
		{
			$newdata['catlist'][] = $myrow['sym_catid'];
		} while ( $myrow = $DB->fetch_row() );
		

		if ( !$std->canEdit($myrow["owner"]) )
	    {
			$std->error(GETLANG("er_noperms"));
			return $main_content;
	    }
		if ( $IN["ACT"] == "deleteimg" )
		{
			$this->files_deleteimg();
			return $main_content;
		}
	    if ( $IN["removefile"] )
		{
			$table = "dl_links";
			$sqlid = "did={$dlid}";
			$type = "maskName";

			if ( $this->removeFile($rwdInfo->path, $table, $sqlid, $dlid, $type) )
			{
				$main_content .= GETLANG("filedl")."<br><br>";
			}
			else
			{
				$main_content .= GETLANG("er_unlink")."<br><br>";
			}
			
			$main_content .= "+ <a href='index.php?ACT=usercp&area=files'>".GETLANG("backto")." ".GETLANG("approved")."</a><br>";
			$main_content .= "+ <a href='index.php?ACT=usercp&area=pending'>".GETLANG("backto")." ".GETLANG("unapproved")."</a><br>";
			$main_content .= "+ <a href='index.php?ACT=usercp&area=editdl&did={$dlid}'>".GETLANG("edit")." ".$myrow['name']."</a><br>";
			
			return $main_content;
	    }

	    if ( $IN["confirm"] )
	    {
			if ( $this->saveEdit($symid, $dlid) )
			{
				$main_content .= "+ <a href='index.php?ACT=usercp&area=editdl&did={$dlid}'>".GETLANG("backto")." ".GETLANG("nav_editdl")." ".$IN["name"]."</a><br>";
				$main_content .= "+ <a href='index.php?dlid={$dlid}'>".GETLANG("backto")." ".$IN["name"]."</a><br>";
				$main_content .= "+ <a href='index.php?ACT=usercp'>".GETLANG("backto")." ".GETLANG("nav_usercp")."</a><br>";
			}
			else
			{
				// TODO: Update failed
			}
			return $main_content;
	    }

	    if ( $IN["preview"] && !$IN["updateform"] )
	    {
			$postlink = "$post";
			$this->previewEdit($postlink);
			return $main_content;
	    }

	    // Else display the edit form
		$formpost = "<form method='post' enctype='multipart/form-data' action='index.php?ACT=usercp&area=editdl&did={$dlid}'>";
		$main_content .= $this->files_dlMainForm($dlid, $symid, $newdata, 0, $formpost);
		
		return $main_content;
	}

	function editPrefs()
	{
	    global $CONFIG, $DB, $guser, $IN, $std;
		
		if ( !empty($IN['skinchoice'] ) )
		{
			$update = array( "skin" => $IN['skinchoice'],
							 "lang" => $IN['langchoice'] );
			$DB->update( $update, "dl_memberextra", "mid={$guser->userid}");
			if ( $CONFIG["usertype"] == USER_DEFAULT )
			{
				$update = array();
				
				if ( $IN['email'] != $guser->userdetails[$guser->db_email] ) 
				{
					if ( $IN['email'] != $IN['email2'] ) 
					{
						$std->error(GETLANG("er_emails_no_match"));
					}
					$update["email"] = $IN['email'];
				}
				
				if ( $IN['password'] && $IN['password2'] ) 
				{
					if ( $IN['password'] != $IN['password2'] ) 
					{
						$std->error(GETLANG("er_nomatch"));
						return $main;
					}
					$update["password"] = md5($IN["password"]);
					$std->rw_setcookie("rwd_password", $update["password"]);
				}
				if (!empty($update)) 
					$DB->update( $update, "dl_users", "id={$guser->userid}");
				
			}
			$main .= $std->info(GETLANG("settingsSaved"));
			return $main;
		}
		
		$data = array(  "username" => $guser->username,
						"email" => $guser->userdetails[$guser->db_email],
						"skin" => $std->skinListBox($guser->userdetails["skin"]),
						"lang" => $std->langListBox($guser->userdetails["lang"]),
						"showoptions" => ( $CONFIG["usertype"] == USER_DEFAULT ) );
		return $main = $this->ucphtml->ucp_profile($data);
	}
}

$loader = new usercp();
?>