<?php

/*********************************************************
 * Name: smf.php
 * Author: Dave Conley
 * Contact: realworld@blazefans.com
 * Description: User class overrides for SMF 1.0.x
 * Version: 4.00
 * Last edited: 26th July, 2005
 *********************************************************/

require_once ROOT_PATH."/functions/users.php";
 
class smfdatabase
{
	var $parent;
	var $name	= "Simple Machines Forum 1.0.x [DO NOT USE]";
	
	function init(&$parent)
	{
		global $CONFIG;
		
		$this->parent = &$parent;
		$this->parent->mem_table = "";
		$this->parent->mem_gtable = "";

		$this->parent->db_id = "ID_MEMBER";
		$this->parent->db_name = "memberName";
		$this->parent->db_password = "passwd";
		$this->parent->db_level = "ID_GROUP";
		$this->parent->db_email = "emailAddress";
		$this->parent->db_g_id = "ID_GROUP";
		$this->parent->db_g_title = "groupName";

		$this->parent->reg_link = $CONFIG["userfileurl"]."/index.php?action=register";
		$this->parent->admin_link = $CONFIG["userfileurl"]."/index.php?action=admin";
	}

	function getDetails($configpath)
	{
		global $CONFIG, $INFO, $std;

		if ( file_exists($configpath."/Settings.php") )
			require_once ($configpath."/Settings.php");
		else
		{
			$std->error("No configuration file was found in the location specified. Current user db is set to {$this->name}. We were expecting to find the file at {$configpath}/Settings.php");
			return false;
		}
		$dbinfo = array("sqlhost" => $db_server,
						"sqlusername" => $db_user,
						"sqlpassword" => $db_passwd,
						"sqldatabase" => $db_name,
						"sql_tbl_prefix" => $db_prefix);

		$this->parent->userdb = new mysql($dbinfo);
		$this->parent->mem_table = $db_prefix."members";
		$this->parent->mem_gtable = $db_prefix."membergroups";

		return true;
	}
	
	function userloader($parent = NULL)
	{
		$this->parent = $parent;
	}
	
	function do_login($username, $password)
	{
		global $IN, $DB, $CONFIG, $std;
					
		// Get user details
		$this->parent->userdb->query(  "SELECT g.{$this->parent->db_g_id}, g.{$this->parent->db_g_title},
										 u.{$this->parent->db_id},u.{$this->parent->db_name},u.{$this->parent->db_level},
										 u.{$this->parent->db_password}, u.{$this->parent->db_email}
								FROM `{$this->parent->mem_table}` u
								LEFT JOIN `{$this->parent->mem_gtable}` g ON (g.{$this->parent->db_g_id}=u.{$this->parent->db_level})
								WHERE u.{$this->parent->db_name}='$username' AND u.{$this->parent->db_password}='$password'");

		$name = $this->parent->userdb->fetch_row();

		// Success?
		if ( empty($name[$this->parent->db_id]) || ($name[$this->parent->db_id] == "") )
		{
			$std->error("There was an error locating the details for this user");
			return false;
		}

		return $name;
	}
	
	function auto_login($userid = -1, $pass = "password")
	{
		global $DB, $IN, $CONFIG, $std;
		
		$sql = "SELECT g.{$this->parent->db_g_id}, g.{$this->parent->db_g_title},
						 u.{$this->parent->db_id},u.{$this->parent->db_name},u.{$this->parent->db_level},
						 u.{$this->parent->db_password}, u.{$this->parent->db_email}
						FROM `{$this->parent->mem_table}` u
						LEFT JOIN `{$this->parent->mem_gtable}` g ON (g.{$this->parent->db_g_id}=u.{$this->parent->db_level})
						WHERE u.{$this->parent->db_id}='$userid' AND u.{$this->parent->db_password}='$pass'";
		// Get user details
		$this->parent->userdb->query( $sql );

		if ($myrow = $this->parent->userdb->fetch_row($result))
		    return $myrow;
		else
		    return false;
		
	}
	
		
	function login($username, $password)
	{
		global $CONFIG, $DB;
			
		$result = $this->parent->userdb->query(  "SELECT g.{$this->parent->db_g_id}, g.{$this->parent->db_g_title},
						    u.{$this->parent->db_id},u.{$this->parent->db_name},u.{$this->parent->db_level},
						    u.{$this->parent->db_password}, u.{$this->parent->db_email}
						    FROM `{$this->parent->mem_table}` u
						    LEFT JOIN `{$this->parent->mem_gtable}` g ON (g.{$this->parent->db_g_id}=u.{$this->parent->db_level})
						    WHERE u.{$this->parent->db_name}='$username' AND u.{$this->parent->db_password}='$password'");

		if ($myrow = $this->parent->userdb->fetch_row($result))
		{
			$result2 = $DB->query("SELECT * FROM `dl_memberextra` WHERE mid={$myrow[$this->parent->db_g_id]}");
			$myrow2 = $DB->fetch_row($result2);
			$result3 = $DB->query("SELECT * FROM `dl_groupsextra` WHERE gid={$myrow[$this->parent->db_level]}");
			$myrow3 = $DB->fetch_row($result3);
			
			if ( $myrow2 )
			    $myrow = array_merge($myrow,$myrow2);
			if ( $myrow3 )
			    $myrow = array_merge($myrow,$myrow3);
			return $myrow;
		}
		else
		    return false;
		
	}

	function uservalidate()
	{
		global $CONFIG, $IN, $DB, $std;

		if ( file_exists($CONFIG['userpath']."/Settings.php") )
			require_once ($CONFIG['userpath']."/Settings.php");
		else
		{
			$std->error("No configuration file was found in the location specified. Current user db is set to {$this->name}. We were expecting to find the file at {$configpath}/Settings.php");
			return false;
		}
	
		$uid = urldecode($std->rw_getcookie($INFO['cookie_id']."member_id"));
		$passhash = urldecode($std->rw_getcookie($INFO['cookie_id']."pass_hash"));
		if ($uid)
		{
			if (!$this->auto_login( $uid, $passhash ))
			{
				$this->parent->username = "Guest User";
				$this->parent->userlevel = $CONFIG["guestid"];
				$this->parent->isGuest = TRUE;

				$result = $DB->query("SELECT * FROM `dl_groupsextra` WHERE gid={$CONFIG['guestid']}");
				$this->parent->userdetails = $DB->fetch_row();

				$std->error(GETLANG("er_duffcookie"));
				
				// Not removing this cookie because its not ours
				/*$std->rw_setcookie("rwd_userid", "0");
				$std->rw_setcookie("rwd_password", "0");
				$std->rw_setcookie("rwd_username", "0");
				$std->rw_setcookie("rwd_userlevel", "0");*/
				
				return false;
			}
    		}
		else
		{
			$this->parent->username = "Guest User";
			$this->parent->userlevel = $CONFIG['guestid'];
			$result = $DB->query("SELECT * FROM `dl_groupsextra` WHERE gid={$CONFIG['guestid']}");
			$this->parent->userdetails = $DB->fetch_row();
			$this->parent->isGuest = TRUE;
			return false;
		}
	}
}

$udbload = new smfdatabase();	
?>