<?php

/*********************************************************
 * Name: users.php
 * Author: Dave Conley
 * Contact: realworld@blazefans.com
 * Description: Base class declaration for user database
 * Version: 4.00
 * Last edited: 7th March, 2005
 *********************************************************/

class user
{
	var $userdb,
		$mem_table,
		$mem_gtable;
		
	var $db_id,
		$db_name,
		$db_password,
		$db_pass_salt,
		$db_level,
		$db_email,
		$db_g_id,
		$db_g_title;

	var $reg_link,
		$admin_link;

	var $usertype;	    // Our database loader

	var $errormsg;
    
	var $username,
		$userlevel,
		$userid,
		$valid,
		$isAdmin,
        $isGuest,
		$langpref,
		$skinpref;
	var $moderator = array();

	var $userdetails;
	
	function user()
	{
		// nothing?
	}
	
	function initialise()
	{
		global $CONFIG, $udbload;
		
		$usertype = preg_replace( "/[^a-zA-Z0-9\-\_]/", "" , $CONFIG['usertype'] );
		require_once ROOT_PATH."/functions/userdb/{$usertype}.php";
		$this->usertype = $udbload;
		$this->usertype->init($this);

		if ( !$this->usertype->getDetails($CONFIG["userfilepath"]))
		    return FALSE;
		else
		    return TRUE;
    
	}
	
	function do_login()
	{
		global $IN, $DB, $CONFIG, $std;
		
		// Make sure username and password were entered
		// NOTE: Error strings in English because lang pack not loaded at this point
		if ( $IN["username"] == "" )
		{
			$this->errormsg = "No username was entered";
			return false;
		}
		if ( $IN["userpw"] == "" )
		{
			$this->errormsg = "No password was entered";
			return false;
		}
		
		// First pass password encryption
		$pass = md5($IN["userpw"]);
		$user = trim($IN["username"]);

		$name = $this->usertype->do_login($user, $pass);

		if (!$name)
		    return;
		  
		$result2 = $DB->query("SELECT * FROM `dl_memberextra` WHERE mid={$name[$this->db_g_id]}");
		$myrow2 = $DB->fetch_row($result2);
		$result3 = $DB->query("SELECT * FROM `dl_groupsextra` WHERE gid={$name[$this->db_level]}");
		$myrow3 = $DB->fetch_row($result3);
		$result4 = $DB->query("SELECT * FROM `dl_moderators` WHERE member_id={$name[$this->db_g_id]}");
		while ($myrow4 = $DB->fetch_row($result4))
		{
			$this->moderator[] = $myrow4;
		}
		if ($myrow2)
			$this->userdetails = array_merge($name,$myrow2);
		if ($myrow3)
			$this->userdetails = array_merge($name,$myrow3);
		$this->username = $this->userdetails[$this->db_name];
		$this->password = $this->userdetails[$this->db_password];
		$this->userlevel = $this->userdetails[$this->db_level];
		$this->userid = $this->userdetails[$this->db_id];
		$this->isAdmin = $this->userdetails["acpAccess"];
		$this->userid = $this->userdetails[$this->db_id];
		$this->langpref = "1";
		$this->valid = true;

		return true;
	}
	
	function auto_login($userid = -1, $pass = "password")
	{
		global $DB, $IN, $CONFIG, $std;

		if ( $userid == -1 )
		{
			$this->errormsg = "Invalid user ID -1";
			return false;
		}

		$myrow = $this->usertype->auto_login($userid, $pass);
		if ( !$myrow )
		{
			$this->errormsg = "The username and password entered is incorrect. Please try to log in again";
			$this->valid = false;
			return false;
		}
		
		$result2 = $DB->query("SELECT * FROM `dl_memberextra` WHERE mid={$myrow[$this->db_id]}");
		$myrow2 = $DB->fetch_row($result2);
		$result3 = $DB->query("SELECT * FROM `dl_groupsextra` WHERE gid={$myrow[$this->db_level]}");
		$myrow3 = $DB->fetch_row($result3);
		$result4 = $DB->query("SELECT * FROM `dl_moderators` WHERE member_id={$myrow[$this->db_id]}");
		while ($myrow4 = $DB->fetch_row($result4))
		{
			$this->moderator[] = $myrow4;
		}
		
		$this->userdetails = $myrow;
		if ($myrow2)
			$this->userdetails = array_merge($this->userdetails,$myrow2);
		if ($myrow3)
			$this->userdetails = array_merge($this->userdetails,$myrow3);
		$this->username = $this->userdetails[$this->db_name];
		$this->password = $this->userdetails[$this->db_password];
		$this->userlevel = $this->userdetails[$this->db_level];
		$this->userid = $this->userdetails[$this->db_id];
		$this->isAdmin = $this->userdetails["acpAccess"];
		$this->userid = $this->userdetails[$this->db_id];
		$this->langpref = "1";
		$this->valid = true;

		return true;
		
		
	}
	
	function login($username = "Guest User", $password = "password")
	{
		global $CONFIG, $DB, $std;
			
		$data = $this->usertype->login($username, $password);
		if ( !$data )
		{
			$this->errormsg = GETLANG("er_oldpass");
			$this->valid = false;
			return false;
		}
		
		$this->userdetails = $data;
		$this->username = $this->userdetails[$this->db_name];
		$this->userlevel = $this->userdetails[$this->db_level];
		$this->userid = $this->userdetails[$this->db_id];
		$this->isAdmin = $this->userdetails["acpAccess"];
		$this->userid = $this->userdetails[$this->db_id];
		$this->langpref = "eng";
		$this->valid = true;

		return true;
		
	}

	function adminLogin($session = "")
	{
		global $DB;
		if ( $session == "" )
			return false;

		$s1 = $DB->query("SELECT * FROM dl_sessions WHERE sID = '$session'");
		$row1 = $DB->fetch_row($s1);
		$uid = $row1["id"];

		$s2 = $this->userdb->query("SELECT * FROM $this->mem_table WHERE $this->db_id = $uid");
		$row2 = $this->userdb->fetch_row($s2);

		return $this->auto_login($row2[$this->db_id], $row2[$this->db_password]);
	}
	
	function uservalidate()
	{
		//return $this->usertype->uservalidate();
		global $CONFIG, $IN, $DB, $std;
		
		$uid = $std->rw_getcookie("rwd_userid");
		if ($uid)
		{
			if (!$this->auto_login( $_COOKIE["rwd_userid"], $_COOKIE["rwd_password"] ))
			{
				$this->username = "Guest User";
				$this->userlevel = $CONFIG["guestid"];
                $this->isGuest = TRUE;
                $this->userid = $CONFIG['guestref'];

                $result = $DB->query("SELECT * FROM `dl_groupsextra` WHERE gid={$CONFIG['guestid']}");
    			$this->userdetails = $DB->fetch_row();

				$this->errormsg = "Your login cookie is invalid. Please re-login to update your cookies";
				
				$std->rw_setcookie("rwd_userid", "0");
			    $std->rw_setcookie("rwd_password", "0");
			    $std->rw_setcookie("rwd_username", "0");
			    $std->rw_setcookie("rwd_userlevel", "0");
				
				return false;
			}
			else
			{
				if ( $CONFIG["usertype"] == USER_DEFAULT )
				{
					$ips = explode("|",$this->userdetails['iplog']);
					
					if ( $IN['ipaddr'] != $ips[0] )
					{
						$iplist = $IN['ipaddr'];
						for ( $i=0; $i<4; $i++ )
						{
							$iplist .= "|".$ips[0];
						}
						$DB->query("UPDATE dl_users SET iplog='{$iplist}' WHERE id={$this->userid}");
					}
					return true;
				}
			}
		}
		else
		{
			$this->username = "Guest User";
			$this->userlevel = $CONFIG['guestid'];
            $result = $DB->query("SELECT * FROM `dl_groupsextra` WHERE gid={$CONFIG['guestid']}");
    		$this->userdetails = $DB->fetch_row();
            // This is really REALLY hacky
            if ( $CONFIG["usertype"] == USER_DEFAULT )
			{
                $DB->query("SELECT * FROM `dl_users` WHERE id={$CONFIG['guestref']}");
                $myrow = $DB->fetch_row();
                if ( $myrow )
                    $this->userdetails = array_merge($this->userdetails, $myrow);
                $DB->query("SELECT * FROM `dl_memberextra` WHERE mid={$CONFIG['guestref']}");
                $myrow = $DB->fetch_row();
                if ( $myrow )
                    $this->userdetails = array_merge($this->userdetails, $myrow);
            }
            $this->isGuest = TRUE;
            $this->userid = $CONFIG['guestref'];
			
			return false;
		}
		
		return true;
    }

	function getAllGroups($query="", $extraQuery="")
	{
		global $CONFIG, $DB;
		$GData = array();

		if ( $CONFIG["usertype"] == USER_DEFAULT )
		{
			$result = $this->userdb->query("SELECT g.*, ge.*
											FROM `{$this->mem_gtable}` g
											LEFT JOIN `dl_groupsextra` ge ON (ge.gid=g.{$this->db_g_id}) $query");
			if ( $data = $this->userdb->fetch_row($result) )
			{
				do
				{
					$GData[$data["gid"]] = $data;
				} while ($data = $this->userdb->fetch_row($result) );
			}

		}
		else
		{
			$groups = array();
			$gextra = array();
			$result = $this->userdb->query("SELECT g.{$this->db_g_id}, g.{$this->db_g_title} FROM `{$this->mem_gtable}` g $query ORDER BY g.{$this->db_g_id}");
			if ( $data = $this->userdb->fetch_row($result) )
			{
				do
				{
					$groups[$data[$this->db_g_id]] = $data;
				} while ($data = $this->userdb->fetch_row($result) );
			}
			$result = $DB->query("SELECT * FROM `dl_groupsextra` ge $extraQuery ORDER BY ge.gid");
			if ( $data = $DB->fetch_row($result) )
			{
				do
				{
					$gextra[$data["gid"]] = $data;
				} while ($data = $DB->fetch_row($result) );
			}

			foreach ( $groups as $i=>$v )
			{
				$found = false;
				foreach ( $gextra as $ei=>$ev )
				{
					if ( $i == $ei )
					{
						$found = true;
						break;
					}
				}
				// Extra data not found
				if ( !$found )
				{
					$insert = array("gid" => $i );
					$DB->insert($insert, "dl_groupsextra");
				}
				else
				{
					$GData[$i] = array_merge($groups[$i], $gextra[$i]);
				}
			}
		}
		return $GData;
	}

	function getAllUsers($query="", $extraQuery="")
	{
		global $CONFIG, $DB, $std;
		$GData = array();

		$groups = array();
		$gextra = array();

        if ( $CONFIG["usertype"] != USER_DEFAULT )
        {
		    $result = $this->userdb->query("SELECT `{$this->db_id}`, `{$this->db_name}`,
												`{$this->db_password}`, `{$this->db_level}`,
												`{$this->db_email}` FROM `{$this->mem_table}` $query ORDER BY `{$this->db_id}`");
        }
        else
        {
            $result = $this->userdb->query("SELECT * FROM `{$this->mem_table}` $query ORDER BY `{$this->db_id}`");
        }
		if ( $data = $this->userdb->fetch_row($result) )
		{
			do
			{
				$groups[$data[$this->db_id]] = $data;
			} while ($data = $this->userdb->fetch_row($result) );
		}
		$result = $DB->query("SELECT * FROM `dl_memberextra` $extraQuery ORDER BY `mid`");
		if ( $data = $DB->fetch_row($result) )
		{
			do
			{
				$gextra[$data["mid"]] = $data;
			} while ($data = $DB->fetch_row($result) );
		}

		foreach ( $groups as $i=>$v )
		{
			$found = false;
			foreach ( $gextra as $ei=>$ev )
			{
				if ( $i == $ei )
				{
					$found = true;
					break;
				}
			}
			// Extra data not found
			if ( !$found )
			{
				$GData[$i] = $groups[$i];
			}
			else
			{
				$GData[$i] = array_merge($groups[$i], $gextra[$i]);
			}
		}

		return $GData;
	}

	function updateMemberExtra($uextra, $extra)
	{
		global $CONFIG, $DB, $std;

        if ( $CONFIG["usertype"] != USER_DEFAULT && $this->isGuest )
            return;

		$newUser = $this->getAllUsers("WHERE $uextra" );
		$groups = $this->getAllGroups();
		
		$insert = array();
        $counter = 0;
		foreach ($newUser as $user)
		{
            if (!array_key_exists("bandwidth", $user))
			{
                foreach($groups as $g)
				{
					if ($user[$this->db_level] == $g[$this->db_g_id])
					{
                        $user = array_merge($user, $g);
                        $insert[$counter] = $std->updateLimits($user, 0);
                        $counter++;
                        break;
					}
				}
			}
            if ( $user[$this->db_level] != $user['gid'] )
            {
                $DB->query("UPDATE `dl_memberextra` SET `gid`='{$user[$this->db_level]}', `bandwidth_time`='0', `files_time`='0' WHERE `mid`='{$user['mid']}'");
                $std->updateLimits($user, 1);
            }
		}

        $numrows = count($insert);

		if ( $numrows )
		{

			$iquery = "INSERT INTO `dl_memberextra` (`mid`, `gid`, `bandwidth`, `files`, `bandwidth_time`, `files_time`) VALUES ";
            $comma = 0;
			foreach ($insert as $i)
			{
                $comma++;
				$iquery .= "('{$i[$this->db_id]}', '{$i[$this->db_level]}', '{$i['bandwidth']}', '{$i['files']}', '{$i['bandwidth_time']}', '{$i['files_time']}')";
                if ( $comma!=$numrows )
                    $iquery .= ", ";
			}
			$DB->query($iquery);
		}
	}
}
	
?>